
'--------------------------------
'long-run regressions   
'----------------------------------
pageselect annual

' detrending with cointegration 
pageselect annual
smpl 1963 2022
equation eq_sm_div.ls l_p_sp= c(1)+c(2)*l_div
equation eq_sm_dem.ls   l_p_sp= c(1)+ c(2)*l_div+ c(3)*my
genr l_p_sp_trend= eq_sm_dem.@coefs(1)+eq_sm_dem.@coefs(2)* l_div+eq_sm_dem.@coefs(3)*my
genr l_p_sp_trend1=eq_sm_div.@coefs(1)+eq_sm_div.@coefs(2)* l_div

genr l_p_sp_dis=l_p_sp-l_p_sp_trend
genr l_p_sp_dis1=l_p_sp-l_p_sp_trend1
genr r_p_sp_l=d(l_p_sp)
equation eq_sm_dem_sr.ls r_p_sp_l= C(1)+0*d(l_div)+0*d(my)+c(4)*l_p_sp_dis(-1)
equation eq_sm_div_sr.ls r_p_sp_l= C(1)+0*d(l_div)+0*d(my)+c(4)*l_p_sp_dis1(-1)
eq_sm_dem_sr.makeresids res_eq_sm_dem_sr
genr r_p_sp_l_fit=r_p_sp_l-res_eq_sm_dem_sr

include figures345.prg
'from annual to monthly data 
pageselect monthly 
smpl 1963:1 2022:12
equation eq_sm_dem.ls l_p_sp= c(1)+c(2)*l_div+c(3)*my

genr l_p_sp_trend= eq_sm_dem.@coefs(1)+ eq_sm_dem.@coefs(2)*l_div+eq_sm_dem.@coefs(3)*my

genr l_p_sp_dis=l_p_sp-l_p_sp_trend
genr r_p_sp_l=d(l_p_sp)
genr r12_p_sp_l=l_p_sp-l_p_sp(-12)
equation eq_sm_dem_sr1.ls r_p_sp_l= C(1)+0*d(l_div)+0*d(my)+c(4)*l_p_sp_dis(-1)
equation eq_sm_dem_sr12.ls r12_p_sp_l= C(1)+0*d(l_div)+0*d(my)+c(4)*l_p_sp_dis(-12)

'----------------------------------
'filtering for trends  
'----------------------------------
pageselect annual
' exponential smoothing 
smpl 1950 1950
genr l_p_sp_star= l_p_sp
smpl 1951 @last
genr l_p_sp_star= 0.8*l_p_sp_star(-1)+ (1-0.8)*l_p_sp
genr l_p_sp_star1= 0.2*l_p_sp_star(-1)+ (1-0.2)*l_p_sp

'hodrick prescott filter recursive and full sample
smpl 1950 @last
hpf l_p_sp l_p_sp_HPfull

smpl 1970 @last
equation eq_sm_hpfull.ls r_p_sp_l= C(1)+c(2)*(l_p_sp(-1)-l_p_sp_hpfull(-1))

smpl 1950 @last
genr l_p_sp_hp_rec=na
for !i=0 to (2050-1970) 
smpl 1950 1950+20+!i
hpf l_p_sp l_p_sp_HP 
smpl 1950+20+!i 1950+20+!i
l_p_sp_hp_rec=l_p_sp_HP
next

smpl 1970 @last
equation eq_sm_hprec.ls r_p_sp_l= C(1)+c(2)*(l_p_sp(-1)-l_p_sp_hp_rec(-1))


'----------------------------------
'cointegration and forecasting 
'----------------------------------
system sys_lpld
sys_lpld.append d(l_p_sp)= C(1)+c(2)*(l_p_sp(-1)-l_div(-1)) 
sys_lpld.append d(l_div)=c(3)
smpl 1950 1990
sys_lpld.ls

model mod_lpld
model mod_lpld.merge sys_lpld 
mod_lpld.append assign @all _sim 
smpl 1991 2022 
mod_lpld.solve(s=b)

smpl 1951 1990 
l_div_simm=l_div(-1) + sys_lpld.@coefs(3) 

system sys_lpldc
sys_lpldc.append l_p_sp= c(1)+c(2)*l_div+c(3)*my
sys_lpldc.append d(l_p_sp)= C(4)+c(5)*(l_p_sp(-1)-c(1)-c(2)*l_div(-1)-c(3)*my(-1))
smpl 1950 1990
sys_lpldc.ls
genr l_p_sp_st= sys_lpldc.@coefs(1)+sys_lpldc.@coefs(2)*l_div+sys_lpldc.@coefs(3)*my

model mod_lpldc
mod_lpldc.append l_p_sp_st= sys_lpldc.@coefs(1)+sys_lpldc.@coefs(2)*l_div+sys_lpldc.@coefs(3)*my
mod_lpldc.append l_p_sp= l_p_sp(-1)+ sys_lpldc.@coefs(4)+sys_lpldc.@coefs(5)*(l_p_sp(-1)-l_p_sp_st(-1))
mod_lpldc.append assign @all _sim1 
smpl 1991 2022 
mod_lpldc.solve(s=b)


include figures678.prg


