workfile sm  m  1871:1 2050:12 
'---------------------------------------------------
'Import monthly data  Shiller
'----------------------------------------------------
pagerename untitled monthly
smpl @first @last
read( b9, s=ie_data ) "data\data.xls" 13
delete fraction*
delete date*

'---------------------------------------------------
'Import monthly data  FRED
'----------------------------------------------------

smpl 1913:1 @last
read( b2, s=FRED_M ) "data\data.xls" 9


'---------------------------------------------------
'Import monthly data  Fama-French
'----------------------------------------------------

smpl 1963:7 @last
read( b2, s=FF_M ) "data\data.xls" 10


'---------------------------------------------------
'Import monthly data  on Dow-Jones Components 
'----------------------------------------------------

smpl 1985:1 @last
read( b2, s=STOCKS_M ) "data\data.xls" 31




'---------------------------------------------------
'Import quarterly  data  FRED+forecast REfinitiv
'----------------------------------------------------
pagecreate(page = quarterly) q  1947:1 2050:4 
smpl @first @last 
read( b12, s=FRED_Q ) "data\data.xls" 9

smpl 1970:1 @last 
read( b2, s=data ) "data\forecasts_ref.xls" 5

'---------------------------------------------------
'Import annual  data  FRED
'----------------------------------------------------
pagecreate(page = annual) a  1871 2050 
smpl @first @last 
read( b12, s=FRED_A ) "data\data.xls" 5

smpl 1978 2050 
read( b12, s=data) "data\mich.xls" 1


'---------------------------------------------------
'creating annual  database  
'----------------------------------------------------
copy(c= l)  monthly\p annual\p
copy(c= l)  monthly\d01 annual\div
copy(c= l)  monthly\cpi annual\cpi
copy(c= l)  monthly\unrate annual\unrate
copy(c= l)  monthly\p quarterly\p
copy(c= l)  monthly\d01 quarterly\div
copy(c= l)  monthly\cpi quarterly\cpi
copy(c= l)  monthly\gs10 quarterly\gs10
copy(c= l)  monthly\unrate quarterly\unrate
copy(c= l)  monthly\dtb3 quarterly\dtb3

copy(c= l)  quarterly\*gdppot annual\*gdppot
copy(c=linearl) annual\my monthly\my
copy(c=linearl) annual\my quarterly\my

'--------------------------------
'data transformation  annual 
'----------------------------------
pageselect annual
smpl @all
genr l_p_sp=log(p)
genr l_div=log(div)
genr l_pd=l_p_sp-l_div
genr l_cpi=log(cpi)
genr l_ypot=log(gdppot)
genr l_ypotn=log(ngdppot) 
genr l_y=log(gdpca)
genr l_gap=l_y-l_ypot
genr us_infl= (cpi-cpi(-1))/cpi(-1)


'--------------------------------
'data transformation  monthly 
'----------------------------------

pageselect monthly
smpl @all
genr l_p_sp=log(p)
genr l_div=log(d01)
genr l_cpi=log(cpi)
genr infl_us= (cpi-cpi(-12))/cpi(-12)
genr infl_us_l= (l_cpi-l_cpi(-12))
genr infl_us_m=(CPI -cpi(-1))/cpi(-1)
genr sh_mkt_tot= (p+d01/12)/p(-1) -1 
genr ff_r_mkt=(ff_exret_mkt+ff_rf)*0.01
genr ff_r_rf=0.01*ff_rf
genr ff_r_rfa=(1+ff_r_rf)^12 -1 
'genr ff_r_mom=0.01*ff_mom
genr ff_r_hml=0.01*ff_hml
genr ff_r_smb=0.01*ff_smb
genr ff_r_cma=0.01*ff_cma
genr ff_r_rmw=0.01*ff_rmw
genr ff_r_er_mkt=(ff_exret_mkt)*0.01


FOR %IDC  ff_hi10 ff_lo10 ff_hi10size ff_lo10size
genr ff_r_{%IDC}=0.01*{%IDC}
genr ff_er_{%IDC}=ff_r_{%IDC}-ff_r_rf
next
smpl 1962:1 1962:1 
genr Port_sh=1
genr Port_sh_infl=1
smpl 1962:2 @last
port_sh=port_sh(-1)*(1+sh_mkt_tot) 
port_sh_infl=port_sh_infl(-1)*(1+infl_us_m) 
FOR %IDC mkt rf er_mkt hml smb cma rmw  ff_hi10 ff_lo10 ff_hi10size ff_lo10size 'mom

smpl 1963:6 1963:6
GENR Port_{%IDC}=1

smpl 1963:7 @last 
Port_{%IDC}=Port_{%IDC}(-1)*(1+ff_r_{%IDC})
genr LPort_{%IDC}=log(Port_{%IDC})
next 

FOR %IDC   ff_hi10 ff_lo10 ff_hi10size ff_lo10size
'
smpl 1963:6 1963:6
GENR Port_er_{%IDC}=1
'
smpl 1963:7 @last 
Port_er_{%IDC}=Port_er_{%IDC}(-1)*(1+ff_er_{%IDC})
genr LPort_er_{%IDC}=log(Port_er_{%IDC})
next 

smpl 1963:7 @last
genr ff_r_mkt_la=lport_mkt-lport_mkt(-12)
genr ff_r_growth_la=lport_ff_lo10-lport_ff_lo10(-12)
genr ff_r_value_la=lport_ff_hi10-lport_ff_hi10(-12)


